    addi    r1, r0, #32 ; initialize loop counter
Loop:
    ld      f0, 0(r1)   ; get value from M into f0
    subi    r1, r1, #8  ; decrement array pointer
    addd    f4, f0, f2  ; add to scalar in f2, result into f4
    bnez    r1, Loop    ; branch if not done
    sd      8(r1), f4   ; store result back into M
    nop
    nop
    nop
    nop
    trap    #0
